{ lib, stdenv, fetchFromGitHub, rgbds }:

stdenv.mkDerivation rec {
  pname = "pokecrystal";
  version = "unstable-2021-07-20";

  src = fetchFromGitHub {
    owner = "pret";
    repo = pname;
    rev = "d93c13c94c3680bace68ee2333dd81b1efad1734";
    sha256 = "sha256-x1sVaZVmZP9iX7jkXhh4owGdzcQ8+wwDrV6VkfhtBVk=";
  };

  nativeBuildInputs = [ rgbds ];

  makeFlags = [ "crystal" "crystal11" ];

  installPhase = ''
    runHook preInstall
    mkdir -p $out
    cp pokecrystal{,11}.gbc $out
    runHook postInstall
  '';

  meta = with lib; {
    description = "ROM built from disassembly of Pokémon Crystal";
    homepage = "https://github.com/pret/pokcrystal";
    license = licenses.unfree;
    maintainers = with maintainers; [ sbruder ];
  };
}
